<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListaPendentesEstabelecimento StructType
 * @subpackage Structs
 */
class ListaPendentesEstabelecimento extends AbstractStructBase
{
    /**
     * The codigoEstabelecimento
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codigoEstabelecimento;
    /**
     * The todosDocumentos
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $todosDocumentos;
    /**
     * The dataInicial
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dataInicial;
    /**
     * The datafinal
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $datafinal;
    /**
     * The forceRefresh
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $forceRefresh;
    /**
     * Constructor method for ListaPendentesEstabelecimento
     * @uses ListaPendentesEstabelecimento::setCodigoEstabelecimento()
     * @uses ListaPendentesEstabelecimento::setTodosDocumentos()
     * @uses ListaPendentesEstabelecimento::setDataInicial()
     * @uses ListaPendentesEstabelecimento::setDatafinal()
     * @uses ListaPendentesEstabelecimento::setForceRefresh()
     * @param string $codigoEstabelecimento
     * @param bool $todosDocumentos
     * @param string $dataInicial
     * @param string $datafinal
     * @param bool $forceRefresh
     */
    public function __construct($codigoEstabelecimento = null, $todosDocumentos = null, $dataInicial = null, $datafinal = null, $forceRefresh = null)
    {
        $this
            ->setCodigoEstabelecimento($codigoEstabelecimento)
            ->setTodosDocumentos($todosDocumentos)
            ->setDataInicial($dataInicial)
            ->setDatafinal($datafinal)
            ->setForceRefresh($forceRefresh);
    }
    /**
     * Get codigoEstabelecimento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodigoEstabelecimento()
    {
        return isset($this->codigoEstabelecimento) ? $this->codigoEstabelecimento : null;
    }
    /**
     * Set codigoEstabelecimento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codigoEstabelecimento
     * @return \StructType\ListaPendentesEstabelecimento
     */
    public function setCodigoEstabelecimento($codigoEstabelecimento = null)
    {
        // validation for constraint: string
        if (!is_null($codigoEstabelecimento) && !is_string($codigoEstabelecimento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codigoEstabelecimento)), __LINE__);
        }
        if (is_null($codigoEstabelecimento) || (is_array($codigoEstabelecimento) && empty($codigoEstabelecimento))) {
            unset($this->codigoEstabelecimento);
        } else {
            $this->codigoEstabelecimento = $codigoEstabelecimento;
        }
        return $this;
    }
    /**
     * Get todosDocumentos value
     * @return bool|null
     */
    public function getTodosDocumentos()
    {
        return $this->todosDocumentos;
    }
    /**
     * Set todosDocumentos value
     * @param bool $todosDocumentos
     * @return \StructType\ListaPendentesEstabelecimento
     */
    public function setTodosDocumentos($todosDocumentos = null)
    {
        // validation for constraint: boolean
        if (!is_null($todosDocumentos) && !is_bool($todosDocumentos)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($todosDocumentos)), __LINE__);
        }
        $this->todosDocumentos = $todosDocumentos;
        return $this;
    }
    /**
     * Get dataInicial value
     * @return string|null
     */
    public function getDataInicial()
    {
        return $this->dataInicial;
    }
    /**
     * Set dataInicial value
     * @param string $dataInicial
     * @return \StructType\ListaPendentesEstabelecimento
     */
    public function setDataInicial($dataInicial = null)
    {
        // validation for constraint: string
        if (!is_null($dataInicial) && !is_string($dataInicial)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dataInicial)), __LINE__);
        }
        $this->dataInicial = $dataInicial;
        return $this;
    }
    /**
     * Get datafinal value
     * @return string|null
     */
    public function getDatafinal()
    {
        return $this->datafinal;
    }
    /**
     * Set datafinal value
     * @param string $datafinal
     * @return \StructType\ListaPendentesEstabelecimento
     */
    public function setDatafinal($datafinal = null)
    {
        // validation for constraint: string
        if (!is_null($datafinal) && !is_string($datafinal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($datafinal)), __LINE__);
        }
        $this->datafinal = $datafinal;
        return $this;
    }
    /**
     * Get forceRefresh value
     * @return bool|null
     */
    public function getForceRefresh()
    {
        return $this->forceRefresh;
    }
    /**
     * Set forceRefresh value
     * @param bool $forceRefresh
     * @return \StructType\ListaPendentesEstabelecimento
     */
    public function setForceRefresh($forceRefresh = null)
    {
        // validation for constraint: boolean
        if (!is_null($forceRefresh) && !is_bool($forceRefresh)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($forceRefresh)), __LINE__);
        }
        $this->forceRefresh = $forceRefresh;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListaPendentesEstabelecimento
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
